import java.util.*;

public class Esame{
  
  
  private static class DataMatrix {
    public double[][] matrix; //matrice dei dati
    public String descrizione; //descrizione dei dati

	/**
	* Costruttore con 2 argomenti
	*
	* @param desc descrizione da assegnare alla matrice
	* @param m matrice dei dati
	*/
    public DataMatrix(String desc, double[][] m){
      descrizione = desc;
      matrix = m;
    }

    public String toString(){
	  String matrixString = "";
	  for (int i=0;i<matrix.length;i++){
		for (int j = 0; j<matrix[0].length;j++){
			matrixString += matrix[i][j]+" "; 					
		}
		matrixString += "\n";
	  }	
      return "("+descrizione+"\n"+matrixString+")";
    }


    /**
    * Implementa il metodo equals per oggetti di tipo dataMatrix.
    * Due oggetti DataMatrix sono uguali se hanno la stessa descrizione e la stessa matrice (i.e., stessi dati nelle stesse posizioni)
    *
    * @param obj oggetto con cui comparare l'oggetto di invocazione
    * @return true se i due oggetti sono uguali false altrimenti. 
    */
    public boolean equals(Object obj){
	  System.out.println("Metodo da implementare");
      return false;	    
    }
	
 } 

  
  /**
  * ritorna un array che rappresenta il massimo per ciascuna colonna di un oggetto DataMatrix (30 Punti). 
  * Assumere che la matrice contenga tutti numeri positivi.	
  * Ad esempio dato l'oggetto 
  * (dm1,{{ 0.5, 0.9, 0.5 },
  *       { 0.3, 0.7, 0.8 },
  *       { 0.2, 0.1, 0.6 }}) 
  * il metodo ritorna 
  * 	  [ 0.5, 0.9, 0.8 ]
  *
  *  @param dm l'oggetto DataMatrix
  *  @return un vettore in cui l'elemento in posizione i e' il massimo della i-esima colonna di dm
  */	
  public static double[] maxColumn(DataMatrix dm){
    System.out.println("Metodo da implementare");
    return new double[0];
  }
  
 
  /**
  * Data una stringa ritorna una mappa che associa il numero di occorrenze di tutte le sottostringhe di lunghezza n che appaiono almeno una volta (punti 25)
  * Ad esempio se la stringa in ingresso e' ATATA ed n=3, la mappa sara' {ATA=2, TAT,1}.
  *
  * @param s stringa in ingresso
  * @param n lunghezza delle sottostringhe di interesse
  * @return un mappa che associa ad ogni sottostringa di lunghezza n (che appare almeno una volta) il numero di occorrenze
  */
  public static Map<String,Integer> allRepeats(String s, int n){
    System.out.println("Metodo da implementare");
    return null;
  }

  /**
  * Dato un grafo g ed un intero n, restituire un insieme di object  che rappresentano i nodi aventi grado maggiore od uguale ad n  (punti 25)
  * Se il grafo non  ha nessun nodo restituisce un insieme vuoto.
  * Si possono usare i metodi getNodeSet() e getDegree(Object node) della classe Grafo.java per ottenere rispettivamente l'insieme dei nodi del grafo ed il grado di un nodo. 
  *
  * @param g grafo
  * @param n grado minimo
  * @return insieme di nodi con grado maggiore o uguale ad n
  */    
  public static Set<Object> getNodeMinDegree(Grafo g, int n){
	 System.out.println("Metodo da implementare");
     return null;
  }


  public static void main(String[] args){

 
    System.out.println("**********TEST equals per datamatrix*************");	
	double[][] m1= {
      { 0.5, 0.9, 0.5 },
      { 0.3, 0.7, 0.8 },
      { 0.2, 0.1, 0.6 },
    };

	double[][] m2= {
      { 0.5, 0.9, 0.5 },
      { 0.1, 0.7, 0.8 },
      { 0.2, 0.1, 0.6 },
    };

	double[][] m3= {
      { 0.5, 0.9, 0.5 },
      { 0.3, 0.7, 0.8 },
    };

    DataMatrix dm1 = new DataMatrix("dm1",m1);
    DataMatrix dm2 = new DataMatrix("dm1",m1);
    DataMatrix dm3 = new DataMatrix("dm1",m2);
    DataMatrix dm4 = new DataMatrix("dm1",m3);
    DataMatrix dm5 = new DataMatrix("dm2",m1);

    System.out.println("DataMatrix "+dm1+" uguale a "+dm2+" ? Risultato: "+dm1.equals(dm2)+" dovrebbe essere true");

    System.out.println("DataMatrix "+dm1+" uguale a "+dm3+" ? Risultato: "+dm1.equals(dm3)+" dovrebbe essere false");

    System.out.println("DataMatrix "+dm1+" uguale a "+dm4+" ? Risultato: "+dm1.equals(dm4)+" dovrebbe essere false");

    System.out.println("DataMatrix "+dm1+" uguale a "+dm5+" ? Risultato: "+dm1.equals(dm5)+" dovrebbe essere false");

    
    System.out.println("**********TEST maxColumn()*************");

	double[] res1 = maxColumn(dm1);
    System.out.println("massimo per colonne di =  "+dm1+" \n "+Arrays.toString(res1)+" dovrebbe essere [0.5, 0.9, 0.8]");
      

    System.out.println("**********TEST getNodeMinDegree*************");
 
	    Object na = "a"; Object nb = "b"; Object nc = "c"; Object nd = "d"; Object ne = "e"; Object nf = "f"; Object nh = "h"; Object nk = "k";

	    Grafo g = new Grafo();    
	    g.add(na,nb,new Integer(1));
	    g.add(nb,nc,new Integer(1));
	    g.add(nb,nd,new Integer(1));
	    g.add(nc,nd,new Integer(1));
	    g.add(nd,ne,new Integer(1));
	    g.add(nd,nf,new Integer(1));
	    g.add(nh);	
    	    g.add(nk);	
	    g.add(nh,nk,new Integer(1));
	
	   System.out.println("insieme di nodi per il grafo "+g+" : "+ getNodeMinDegree(g,1) +" should be [a,b,c,d,e,f,h,k]");

	   System.out.println("insieme di nodi per il grafo "+g+" : "+ getNodeMinDegree(g,2) +" should be [d,b,c]");

	   System.out.println("insieme di nodi per il grafo "+g+" : "+ getNodeMinDegree(g,5) +" should be []");

    
    System.out.println("**********TEST allRepeats()*************");

	String s = "ATATA";
    System.out.println("all repeats per <"+s+"> di lunghezza 3 "+allRepeats(s,3)+" dovrebbe essere {ATA=2, TAT=1}");
       
    System.out.println("all repeats per <"+s+"> di lunghezza 3 "+allRepeats(s,2)+" dovrebbe essere {AT=2, TA=2}");
    
  }

}
